#ifndef __CRSPOINT_H__
#define __CRSPOINT_H__

#include <list>
using  std::list;

#include <stdio.h>

#include "Vec.h"
#include "Mat.h"

inline bool less_than ( const VecC & v1, const VecC & v2) 
{
   if(v1[0] < v2[0])return true;
   else if(v1[0] == v2[0] && v1[1] < v2[1]) return true;
   else return false;
}
inline bool less_than ( VecC & v1, VecC & v2) 
{
   if(v1[0] < v2[0])return true;
   else if(v1[0] == v2[0] && v1[1] < v2[1]) return true;
   else return false;
}

inline bool equal ( const VecC & v1, const VecC & v2) 
{
   return (v1[0] == v2[0] && v1[1] == v2[1]);
}
inline bool equal (VecC & v1,  VecC & v2)
{
   return (v1[0] == v2[0] && v1[1] == v2[1]);
}

inline bool not_equal ( const VecC & v1, const VecC & v2) 
{
   return (v1[0] != v2[0] || v1[1] != v2[1]);
}
inline bool not_equal (VecC & v1,  VecC & v2)
{
   return (v1[0] != v2[0] || v1[1] != v2[1]);
}

class CORRES_POINT{
  public:
   VecC alpha,beta;
   double similarity;
   bool operator<(const CORRES_POINT &crsp) const
      {
         return less_than(alpha, crsp.alpha);
      }
};


int show_match_point(list<CORRES_POINT> &crsp_list);

#endif
