#include <iostream>
#include <new>

using std::cerr;
using std::endl;

#include "misc.h"
#include "Image.h"
#include "Gauss.h"

Gauss::Gauss(int r, double v): range(r), var(v)
{
   table = new double*[2*range+1];
   if(!table){
      cerr <<"can't get memory. Gauss()"<<endl;
   }
   for(int i=0; i<2*range+1; i++){
      table[i] = new double[2*range+1];
      if(!table[i]){
         cerr <<"can't get memory. Gauss()"<<endl;
      }
   }
//   var = (2*range+1)*(2*range+1)/36.0;  //ơ֥ιפ 0.994ʾȤʤʬ

   for(int   i=-range; i < range + 1; i++){
      for(int j=-range; j < range + 1; j++){
         table[range + i][ range + j] = exp( - (double)(i*i +j*j) / (2*var) ) / (2*M_PI*var);
      }
   }			
}

Gauss::~Gauss()
{
   if(table)delete[] table;
   table=0;
}
		
//pt˵βǤȤΥŤߤĤʿ
double
Gauss::smoothing(const Image & im, const VecC &pt) const
{
   double dmi = 0.0;//٥Υ
   int u = (int)(pt[0]);
   int v = (int)(pt[1]);
   int width=im.xl(), height=im.yl();
  
   if(!is_in_image(pt, range, range, width - range , height - range)){
      return -1.0;
   }
   //(u,v)Ȥμ˥ơ֥ˤŤߤղäͤ롣
   for (int i=0; i < 2*range+1; i++){
      for (int j=0; j < 2*range+1; j++){
         dmi += im.rget( u - range + j, v - range + i) * table[i][j];
      }
   }
   return dmi;
}
