#ifndef __SMOOTHINGFILTER_H__
#define __SMOOTHINGFILTER_H__

#include <iostream>

using std::cerr;
using std::endl;

#include <stdlib.h>// abs()
#include <assert.h>// assert()

#include "Image.h"

//ʿʬե륿饹
class SmoothingFilter{
   double *mask;
   int _range;
  
   void allocate_mask(){
      assert(_range > 0);
      mask = new double[(2*_range+1)*(2*_range+1)];
      if(!mask){
         cerr <<"can't get Smoothing Filter"<<endl;
         exit(1);
      }	  	  
   } 
  
  public:
	 
   SmoothingFilter(){
      mask = 0;
      _range = 0;
   }
  
   SmoothingFilter(int range){
      assert(range > 0);// becouse filter size must not be 0
      _range = range;
      allocate_mask();
   }
  
   ~SmoothingFilter(){
      if(mask)
         delete [] mask;
   }
   int get_filter_size() const {
      return _range;
   }
   //ͤΥå
   void put(int x, int y, double data){
      assert(abs(x) <= _range && abs(y) <= _range);
      mask[(2*_range+1)*(y+_range) + _range + x] = data;
   }
  
   //ͤμФ
   double get(int x, int y) const {
      assert(abs(x) <= _range && abs(y) <= _range);
      return mask[(2*_range+1)*(y+_range) + _range + x];
   }
  
   //x(u)ʿʬե륿롣
   //
   // var    ʬ
   // range  ե륿 (2*range+1)*(2*range+1)
   bool make_x_filter(double var, int range)
      {		
         assert(range > 0 && var != 0.0);
         if(_range == 0){
            _range = range;
            allocate_mask();
         }
         //ʬƤ
         double denominator = 0.0,  x2, y2;	
         for(int x = -range; x <= range; x++){
            x2 = x*x;
            for(int y = -range; y <= range; y++){
               y2 = y*y;
               denominator += x2 * exp( - (x2+y2)/var );
            }	
         }
	
         assert(denominator != 0);
		
         double pixel;
         //ե륿
         for(  int x = -range; x <= range; x++){
            x2 = x*x;
            for(int y = -range; y <= range; y++){
               y2 = y*y;
               pixel = (double)x * exp( - (x2+y2)/var ) / denominator;
               put(x,y,pixel);
            }
         }	
         return true;
      }
  
  
   //y(v)ʿʬե륿롣
   //
   // var    ʬ
   // range  ե륿 (2*range+1)*(2*range+1)
   bool make_y_filter(double var, int range)
      {  
         assert(range > 0 && var != 0.0);
         if(_range == 0){
            _range = range;
            allocate_mask();
         }
         //ʬƤ
         double denominator = 0.0,  x2, y2;	
         for(int x = -range; x <= range; x++){
            x2 = x*x;
            for(int y = -range; y <= range; y++){
               y2 = y*y;
               denominator += y2 * exp( - (x2+y2)/var );
            }	
         }
		
         assert(fabs(denominator) < 1e-10);
		
         double pixel;
         //ե륿
         for(  int x = -range; x <= range; x++){
            x2 = x*x;
            for(int y = -range; y <= range; y++){
               y2 = y*y;
               pixel = (double)y * exp( - (x2+y2)/var ) / denominator;
               put(x,y,pixel);
            }
         }	
         return true;
      }
	
};
#endif
