#ifndef __VOTE_H__
#define __VOTE_H__

#include <list>
#include <fstream>
using std::ofstream;
using std::list;

#include "Image.h"
#include "TriVecDescTable.h"
#include "TriangleVector.h"
#include "Gauss.h"
#include "CrsPoint.h"

typedef struct tagCouple{
   int a,b;
   double sim;
}Couple;
	 
class Vote{
   double **voting_table;
   int num1,num2;
  
   //   
   double pv_th, str_th, triangle_th;
   double pv_weight,str_weight,triangle_weight;
   //1Ȳ2¤Τ줾Ȥ뻰ȥ٥ȥ뷴ˤơ
   //ȥ٥ȥ٤׻٤ɼơ֥ɼ롣
   //٤ϺǤ餷Ȥ߹碌Ǥۤ礭ͤȤʤꡢ
   //Ͱʲξ0Ͱʾξ0礭ͤȤʤ롣
   void vote_TriVector_at_point(const TriVectorArray &alpha,
                                const TriVectorArray &beta,
                                list<Couple> &couple_list,
                                const vector<int>& alpha_index_array,
                                const vector<int>& beta_index_array);

   void vote_Triangle(const TriVectorTable &tv_table1,
                      const TriVectorTable &tv_table2,
                      const FeaturePointTable &feature1,
                      const FeaturePointTable &feature2,
                      const Image & img1,const Image &img2,
                      const Gauss & gauss,
                      list<Couple> &couple_list,
                      int alpha, int beta, int triangle_length);
   void extract_one2one_pair(const FeaturePointTable &feature1,
                             const FeaturePointTable &feature2,
                             double vote_th,
                             list<CORRES_POINT> &crsp_list);
  public:
   Vote(){voting_table = 0;}
   ~Vote()
      {
         if(voting_table){
            for(int i=0; i<num1; i++){
               if(voting_table[i])delete[] voting_table[i];
            }
            delete[] voting_table;
         }
      }
	
   void initialize(double _pv_th, double _str_th, double _triangle_th,
                   double _pv_weight, double _str_weight, double _triangle_weight,
                   int _num1, int _num2);
	
   // ѷΰȻȥ٥ȥΤ줾٤ɼ롣
   // tv_table1, tv_table2 : Ʋ鸡Фȥ٥ȥ
   // feature1,  feature2  : Ʋ鸡Фħ
   // img1, img2           : ϲ
   // gauss                : ʿ경ե륿
   // triangle_length      : ѷΰʬ䷸ K
   // vote_th              : ɼͤ
   // crsp_list            : б̳Ǽꥹ(11б)	
   void voting(const TriVectorTable &tv_table1,
               const TriVectorTable &tv_table2,
               const FeaturePointTable &feature1,
               const FeaturePointTable &feature2,
               const Image & img1, const Image &img2,
               const Gauss & gauss,int triangle_length,
               double vote_th,
               list<CORRES_POINT> &crsp_list);
   void show()
      {
	 
         ofstream fout1("voting_img1.dat");
         for(int i=0; i<num1; i++){
            double max = 0.0;
            int index = -1;
            for(int j=0; j<num2; j++){
               if(max < voting_table[i][j]){
                  index = j;
                  max = voting_table[i][j];
               }				  
            }
            if(index >= 0){
               fout1 << i <<" : "<< index<<" = "<<max<<"\n";
            }
         }
	  
         ofstream fout2("voting_img2.dat");
         for(int i=0; i<num2; i++){
            double max = 0.0;
            int index = -1;
            for(int j=0; j<num1; j++){
               if(max < voting_table[j][i]){
                  index = j;
                  max = voting_table[j][i];
               }				  
            }
            if(index >= 0){
               fout2 << index <<" : "<< i<<" = "<<max<<"\n";
            }
         }
      }
};
  
#endif
