#ifndef _VEC_H_
#define	_VEC_H_

//
// n٥ȥΥ饹
//
#if __GNUC__ < 3
# include <iostream.h>
# include <math.h>
# include <stdlib.h>
# include <assert.h>
#else
# include <iostream>
# include <cmath>
# include <cstdlib>
# include <cassert>
#endif

#include "misc.h"

#define	DEFAULT_SIZE	3

#ifndef	False
#define	False	0
#endif

#ifndef	True
#define	True	1
#endif

//
// ͸(ᥤǥХɬ)
//
extern	double	EPS;

//
// ͸(󼰷׻)
//
extern	double	DET_EPS;

class	Mat;
class	Vec;
class	VecR;
class	VecC;

//
// ܥ饹 Vec: ٥ȥΰ̷
//
class Vec
{
   friend class	Mat;
 protected:	// 饹(VecC, VecR)ǥΤǥץƥ
   double	*vec;
   int		_n;
   		Vec(int n)
		{
                   double       *p;
		   p = vec = new double[_n = n];
		   if (p == NULL)
		   {
		      std::cerr << "### Memory Alloc Error (Vec.Vec) ###\n";
		      abort();
		   }
		   //for (int i = 0; i < _n; i++)
		   //   *p++ = 0.0;
		}
   		Vec(const double* v, int n = DEFAULT_SIZE)
		{
		   double *p;
		   const double *q = v;
		   p = vec = new double[_n = n];
		   if (p == NULL)
		   {
		      std::cerr << "### Memory Alloc Error (Vec.Vec) ###\n";
		      abort();
		   }
		   for (int i = 0; i < _n; i++)
		      *p++ = *q++;
		}
   		Vec(double d1, double d2, double d3)
		{
                   double       *p;
		   p = vec = new double[_n = 3];
		   if (p == NULL)
		   {
		      std::cerr << "### Memory Alloc Error (Vec.Vec) ###\n";
		      abort();
		   }
		   *p++ = d1; *p++ = d2; *p++ = d3;
		}
   		Vec(const Vec& V)
		{
                   double       *p, *q = V.vec;
		   p = vec = new double[_n = V._n];
		   if (p == NULL)
		   {
		      std::cerr << "### Memory Alloc Error (Vec.Vec) ###\n";
		      abort();
		   }
		   for (int i = 0; i < _n; i++)
		      *p++ = *q++;
		}
   virtual	~Vec() { delete [] vec; }

 public:
   double&	operator [] (int i) const
                {
		   assert((i >= 0) && (i < _n));
		   return *(vec + i);
		}
   Vec& operator = (const double a[])
   		{
                   double       *p = vec;
                   const double *q = a;
		   for (int i = 0; i < _n; i++)
		      *p++ = *q++;
		   return *this;
		}
   Vec&	operator *= (double a)
                {
                   double       *p = vec;
		   for (int i = 0; i < _n; i++)
		      *p++ *= a;
		   return *this;
		}
   Vec&	operator /= (double a)
                {
                   double       *p = vec;
		   for (int i = 0; i < _n; i++)
		      *p++ /= a;
		   return *this;
                }
   void		renew(int n);
   double	norm() const;
   double	sqrnorm() const;
   int		size() const { return _n; }
   void		clear(double data = 0.0)
                {
                   double       *p = vec;
                   for (int i = 0; i < _n; i++)
                      *p++ = data;
                }
#if __GNUC__ < 3
   friend istream&	operator >> (istream& s, Vec& V);
#else
   friend std::istream&	operator >> (std::istream& s, Vec& V);
#endif
   friend int	operator == (const Vec& V1, const Vec& V2);
   friend int	operator != (const Vec& V1, const Vec& V2);
   friend double	norm(const Vec& V);
   friend double	sqrnorm(const Vec& V);
};

//
// ƳХ饹 VecR: ԥ٥ȥ
//
class VecR: public Vec
{
 public:
   		VecR(int n = DEFAULT_SIZE): Vec(n) {}
   		VecR(const double* v, int n = DEFAULT_SIZE): Vec(v, n) {}
		VecR(double d1, double d2, double d3): Vec(d1, d2, d3) {}
		VecR(const VecR& RV): Vec(RV) {}
   void		realloc(int n);
   VecR&	operator = (const VecR& RV)
	        {
                   double       *p = vec, *q = RV.vec;
		   if (this == &RV) return *this;
		   assert(RV._n == _n);
		   for (int i = 0; i < _n; i++)
		      *p++ = *q++;
		   return *this;
		}
   VecR&	operator += (const VecR& RV)
   		{
                   double       *p = vec, *q = RV.vec;
		   assert(RV._n == _n);
		   for (int i = 0; i < _n; i++)
		      *p++ += *q++;
		   return *this;
		}
   VecR&	operator -= (const VecR& RV)
   		{
                   double       *p = vec, *q = RV.vec;
		   assert(RV._n == _n);
		   for (int i = 0; i < _n; i++)
		      *p++ -= *q++;
		   return *this;
		}
   friend VecR	operator / (const VecR& V, double a);
   friend VecR	operator * (const VecR& V, double a);
   friend VecR	operator * (double a, const VecR& V);
   friend double operator * (const VecR& RV, const VecC& CV);
   friend double operator , (const VecR& V1, const VecR& V2);
   friend VecC	operator ~ (const VecR& V);
   friend VecR	operator % (const VecR& V1, const VecR& V2);
   friend VecR	operator + (const VecR& V1, const VecR& V2);
   friend VecR	operator - (const VecR& V1, const VecR& V2);
   friend VecR	operator - (const VecR& V);
   friend VecR	abs(const VecR& V);
#if __GNUC__ < 3
   friend ostream&	operator << (ostream& s, const VecR& V);
#else
   friend std::ostream&	operator << (std::ostream& s, const VecR& V);
#endif
   friend VecR	normalize(const VecR& V);
};

//
// ƳХ饹 VecC: ٥ȥ
//
class VecC: public Vec
{
 public:
   		VecC(int n = DEFAULT_SIZE): Vec(n) {}
   		VecC(const double* v, int n = DEFAULT_SIZE): Vec(v, n) {}
		VecC(double d1, double d2, double d3): Vec(d1, d2, d3) {}
		VecC(const VecC& CV): Vec(CV) {}
   void		realloc(int n);
   VecC&	operator = (const double a[])
	        {
                   double       *p = vec;
                   const double *q = a;
		   for (int i = 0; i < _n; i++)
		      *p++ = *q++;
		   return *this;
		}
   VecC&	operator = (const VecC& CV)
	        {
                   double       *p = vec, *q = CV.vec;
		   if (this == &CV) return *this;
		   assert(CV._n == _n);
		   for (int i = 0; i < _n; i++)
		      *p++ = *q++;
		   return *this;
		}
   VecC&	operator += (const VecC& CV)
   		{
                   double       *p = vec, *q = CV.vec;
		   assert(CV._n == _n);
		   for (int i = 0; i < _n; i++)
		      *p++ += *q++;
		   return *this;
		}
   VecC&	operator -= (const VecC& CV)
   		{
                   double       *p = vec, *q = CV.vec;
		   assert(CV._n == _n);
		   for (int i = 0; i < _n; i++)
		      *p++ -= *q++;
		   return *this;
		}
   friend VecC	operator / (const VecC& V, double a);
   friend VecC	operator * (const VecC& V, double a);
   friend double operator * (const VecR& RV, const VecC& CV);
   friend VecC	operator * (double a, const VecC& V);
   friend double operator , (const VecC& V1, const VecC& V2);
   friend VecR	operator ~ (const VecC& V);
   friend VecC	operator % (const VecC& V1, const VecC& V2);
   friend VecC	operator + (const VecC& V1, const VecC& V2);
   friend VecC	operator - (const VecC& V1, const VecC& V2);
   friend VecC	operator - (const VecC& V);
   friend VecC	abs(const VecC& V);
#if __GNUC__ < 3
   friend ostream&	operator << (ostream& s, const VecC& V);
#else
   friend std::ostream&	operator << (std::ostream& s, const VecC& V);
#endif
   friend VecC	normalize(const VecC& V);
};

// ٥ȥž
inline VecR
operator ~ (const VecC& V)
{
   return VecR(V.vec, V._n);
}

inline VecC
operator ~ (const VecR& V)
{
   return VecC(V.vec, V._n);
}

// ٥ȥ
inline VecR
operator + (const VecR& V1, const VecR& V2)
{
   VecR	T(V1);
   return T += V2;
}

inline VecC
operator + (const VecC& V1, const VecC& V2)
{
   VecC	T(V1);
   return T += V2;
}

// ٥ȥκ
inline VecR
operator - (const VecR& V1, const VecR& V2)
{
   VecR	T(V1);
   return T -= V2;
}

inline VecC
operator - (const VecC& V1, const VecC& V2)
{
   VecC	T(V1);
   return T -= V2;
}

// 顼
inline VecC
operator * (double a, const VecC& V)
{
   return V * a;
}

inline VecR
operator * (double a, const VecR& V)
{
   return V * a;
}

// Υ
inline double
norm(const Vec& V)
{
   return V.norm();
}

// Υ
inline double
sqrnorm(const Vec& V)
{
   return V.sqrnorm();
}

// ԥ٥ȥ٥ȥ
inline double
operator * (const VecR& RV, const VecC& CV)
{
   return ((~RV) , CV);
}

#endif // _VEC_H_
