#include <iostream.h>
#include <math.h>
#include "Quat.h"
// ---------------------------------------------------------------------- 
#define DEG2RAD(d) ((double)d * M_PI / 180.0)
#define RAD2DEG(r) ((double)r * 180.0 / M_PI)
// ---------------------------------------------------------------------- 
static Mat make_Xrot(double degree)
{
    Mat m;
    m.clear();
    double theta = DEG2RAD(degree);
    m[0][0] = 1;    m[1][1] =  cos(theta);    m[1][2] = -sin(theta);
    m[2][1] =  sin(theta);    m[2][2] =  cos(theta);
    return m;
}
// ---------------------------------------------------------------------- 
static Mat make_Yrot(double degree)
{
    Mat m;
    m.clear();
    double theta = DEG2RAD(degree);
    m[0][0] =  cos(theta);    m[0][2] =  sin(theta);
    m[1][1] = 1;    m[2][0] = -sin(theta);    m[2][2] =  cos(theta);
    return m;
}
// ---------------------------------------------------------------------- 
void test_quat_1()
{
   cout << "<< 4Υƥ1 >>" << endl;

   Quat q1(2,  3,  5, 7);
   Quat q2(8, -5, -2, 3);

   cout << "4: q1 = " << q1 << endl;
   cout << "4: q2 = " << q2 << endl;
   cout << ": q1 + q2 = " << q1 + q2 << endl;
   cout << "顼: q1 * 3 = " << q1 * 3 << endl;
   cout << "顼: q1 / 2 = " << q1 / 2 << endl;
   cout << ": (q1,q2) = " << (q1, q2) << endl;
   cout << "Υ: q1.norm() = " << q1.norm() << endl;
   cout << ": q1.inverse() = " << q1.inverse() << endl;
   cout << ": q1.normalize() = " << q1.normalize() << endl;
   cout << ": q1.conjugate() = " << q1.conjugate() << endl;
   cout << endl;

#if 0
   // ž٥ȥ
   VecC v(3, 5, 7);
   // ٥ȥžޥȥꥯ
   Mat R(1, 0, 0,   0, 1, 0,   0, 0, 1);
   // ٥ȥž륯˥
   Quat QR = Quat(R);

   VecC v1 = R * v;
   VecC v2 = ~((QR * Quat(0, v) * QR.inverse()).getVecR());
   cout << v1 << v2 << endl;
   
   // ˥ޥȥꥯѴ
   cout << QR << endl;
   cout << QR.getMat() << endl;
#endif
}
// ---------------------------------------------------------------------- 
void test_quat_2()
{
    VecC v(0, 0, 1);   
    cout << "<< 4Υƥ2 >>" << endl;

    Mat R = make_Xrot(30);
    cout << " R : xޤ30٤βž" << R << endl;

    Quat qR = Quat(R);
    cout << "4 qR :  R  " << qR << endl;
    cout << "qR.getMat() =" << qR.getMat() << endl;
    cout << " R ǥ٥ȥ vž" << endl;
    cout << "R * v = " <<  R * v << endl;
    cout << "4 qR ǥ٥ȥ vž" << endl;
    cout << "qR * Quat(0, ~v) * qR.inverse() = " 
	 <<  qR * Quat(0, ~v) * qR.inverse() << endl << endl;

    cout << "<4><ž>" << endl;
    Quat qX, qY, qZ;
    qX.setRotate(VecR(1, 0, 0), DEG2RAD(30));
    qY.setRotate(VecR(0, 1, 0), DEG2RAD(40));
    qZ.setRotate(VecR(0, 0, 1), DEG2RAD(50));
    
    cout << "4ǥ٥ȥvž : ";
    Quat Q = qZ * qY * qX * Quat(0, ~v) * 
	qX.inverse() * qY.inverse() * qZ.inverse();
    cout << Q.getVecR() << endl;
    cout << "žǥ٥ȥvž : ";
    cout <<  qZ.getMat() * qY.getMat() * qX.getMat() * v << endl << endl;

    Quat q, q1, q2;
    VecR v1, v2;

    v1 = ~(make_Xrot(-30) * v);
    v2 = ~(make_Xrot(-80) * v);
    q1 = Quat(0, v1);    q2 = Quat(0, v2);
    cout << "v1" << v1 << " v2" << v2 << "" << endl;
    for (double t = 0; t <= 1; t += 0.1)
    {
	q = slerp(q1, q2, t);
	cout << "t=" << t << " : v=" << q.getVecR()
	     << " norm=" << v.norm() 
	     << " deg=" << RAD2DEG(asin(q.getVecR()[1])) << endl;
    }
    cout << endl;
    
    v1 = ~(make_Yrot(40) * make_Xrot(-30) * v);
    v2 = ~(make_Yrot(70) * make_Xrot(-80) * v);
    q1 = Quat(0, v1);    q2 = Quat(0, v2);
    cout << "v1" << v1 << " v2" << v2 << "" << endl;
    for (double t = 0; t <= 1; t += 0.1)
    {
	q = slerp(q1, q2, t);
	cout << "t=" << t << " : v=" << q.getVecR()
	     << " norm=" << v.norm() << endl;
    }
    cout << endl;
    
    cout << "Ǥդβž R0  R1  R(t)" << endl;
    Mat R0, R1;
    qX.setRotate(VecR(1, 0, 0), DEG2RAD(30));
    qY.setRotate(VecR(0, 1, 0), DEG2RAD(40));
    qZ.setRotate(VecR(0, 0, 1), DEG2RAD(50));    
    R0 = qZ.getMat() * qY.getMat() * qX.getMat();
    cout << "R0 = " << R0 << endl;

    qX.setRotate(VecR(1, 0, 0), DEG2RAD(80));
    qY.setRotate(VecR(0, 1, 0), DEG2RAD(-30));
    qZ.setRotate(VecR(0, 0, 1), DEG2RAD(20));    
    R1 = qZ.getMat() * qY.getMat() * qX.getMat();
    cout << "R1 = " << R1 << endl;

    Quat qR0(R0), qR1(R1);
    for (double t = 0; t <= 1; t += 0.2)
    {
	qR = slerp(qR0, qR1, t);
	cout << "R(" << t << ") = " << qR.getMat() <<  endl;
    }
}
// ---------------------------------------------------------------------- 
int main(int argc, char *argv[])
{
    test_quat_1();
    test_quat_2();
}
