#include <iostream>

using std::cerr;

#include "Tensor_used_by_matcher.h"
#include "Cast_used_by_matcher.h"

//6٥ȥ->(33)
Mat
Type33sym(const VecC& vect)
{
   if (vect.size() == 6)
   {
      double root2 = sqrt(2.0);
      
      return Mat(root2*vect[0], vect[5], vect[4],
		 vect[5], root2*vect[1], vect[3],
		 vect[4], vect[3], root2*vect[2])/root2;
   }
   
   cerr << "Function Type33sym error!\n";
   exit(1);
}

//9٥ȥ->33
Mat
Type33(const VecC& vec)
{
   if (vec.size() == 9)
   {
      Mat ret;
      for (int i = 0; i < 3; i++)
	 for (int j = 0; j < 3; j++)
	    ret[i][j] = vec[3*i + j];
      
      return ret;
   }
   
   cerr << "Function Type33 error!\n";
   exit(1);
}

//33->9٥ȥ
VecC
Type9(const Mat& mat)
{
   if (mat.row() == 3 && mat.col() == 3)
   {
      VecC ret(9);
      
      for (int i = 0; i < 3; i++)
	 for (int j = 0; j < 3; j++)
	    ret[3*i+j] = mat[i][j];
      
      return ret;
   }
   
   cerr << "Function Type9 error!\n";
   exit(1);
}

//3333ƥ󥽥->99
Mat
Type99(const Tensor3333& tens)
{
   Mat	ret(9, 9);
      
   for (int i = 0; i < 3; i++)
      for (int j = 0; j < 3; j++)
	 for (int k = 0; k < 3; k++)
	    for (int l = 0; l < 3; l++)
	       ret[3*i+j][3*k+l] = tens(i, j, k, l);
   return ret;
}

//(33)(33)ƥ󥽥->66
Mat
Type66(const Tensor3333& tens)
{
   Mat 	ret(6, 6);
   double root2 = sqrt(2.0);
      
   ret[0][0] = tens(0, 0, 0, 0);
   ret[1][0] = tens(1, 1, 0, 0);
   ret[2][0] = tens(2, 2, 0, 0);
   ret[3][0] = root2*tens(1, 2, 0, 0);
   ret[4][0] = root2*tens(2, 0, 0, 0);
   ret[5][0] = root2*tens(0, 1, 0, 0);
      
   ret[0][1] = tens(0, 0, 1, 1);
   ret[1][1] = tens(1, 1, 1, 1);
   ret[2][1] = tens(2, 2, 1, 1);
   ret[3][1] = root2*tens(1, 2, 1, 1);
   ret[4][1] = root2*tens(2, 0, 1, 1);
   ret[5][1] = root2*tens(0, 1, 1, 1);
      
   ret[0][2] = tens(0, 0, 2, 2);
   ret[1][2] = tens(1, 1, 2, 2);
   ret[2][2] = tens(2, 2, 2, 2);
   ret[3][2] = root2*tens(1, 2, 2, 2);
   ret[4][2] = root2*tens(2, 0, 2, 2);
   ret[5][2] = root2*tens(0, 1, 2, 2);
      
   ret[0][3] = root2*tens(0, 0, 1, 2);
   ret[1][3] = root2*tens(1, 1, 1, 2);
   ret[2][3] = root2*tens(2, 2, 1, 2);
   ret[3][3] = 2.0*tens(1, 2, 1, 2);
   ret[4][3] = 2.0*tens(2, 0, 1, 2);
   ret[5][3] = 2.0*tens(0, 1, 1, 2);
      
   ret[0][4] = root2*tens(0, 0, 2, 0);
   ret[1][4] = root2*tens(1, 1, 2, 0);
   ret[2][4] = root2*tens(2, 2, 2, 0);
   ret[3][4] = 2.0*tens(1, 2, 2, 0);
   ret[4][4] = 2.0*tens(2, 0, 2, 0);
   ret[5][4] = 2.0*tens(0, 1, 2, 0);
      
   ret[0][5] = root2*tens(0, 0, 0, 1);
   ret[1][5] = root2*tens(1, 1, 0, 1);
   ret[2][5] = root2*tens(2, 2, 0, 1);
   ret[3][5] = 2.0*tens(1, 2, 0, 1);
   ret[4][5] = 2.0*tens(2, 0, 0, 1);
   ret[5][5] = 2.0*tens(0, 1, 0, 1);
      
   return ret;
}

//66->(33)(33)ƥ󥽥
Tensor3333
Type3333sym(const Mat& M)
{
   if ((M.row() == 6) && (M.col() == 6))
   {
      Tensor3333 T;
      double root2 = sqrt(2.0);
      
      T(0,0,0,0) = M[0][0];
      T(1,1,0,0) = M[1][0];
      T(2,2,0,0) = M[2][0];
      T(2,1,0,0) = T(1,2,0,0) = M[3][0]/root2;
      T(0,2,0,0) = T(2,0,0,0) = M[4][0]/root2;
      T(1,0,0,0) = T(0,1,0,0) = M[5][0]/root2;
      
      T(0,0,1,1) = M[0][1];
      T(1,1,1,1) = M[1][1];
      T(2,2,1,1) = M[2][1];
      T(1,2,1,1) = T(2,1,1,1) = M[3][1]/root2;
      T(2,0,1,1) = T(0,2,1,1) = M[4][1]/root2;
      T(0,1,1,1) = T(1,0,1,1) = M[5][1]/root2;
      
      T(0,0,2,2) = M[0][2];
      T(1,1,2,2) = M[1][2];
      T(2,2,2,2) = M[2][2];
      T(1,2,2,2) = T(2,1,2,2) = M[3][2]/root2;
      T(2,0,2,2) = T(0,2,2,2) = M[4][2]/root2;
      T(0,1,2,2) = T(1,0,2,2) = M[5][2]/root2;
      
      T(0,0,1,2) = T(0,0,2,1) = M[0][3]/root2;
      T(1,1,1,2) = T(1,1,2,1) = M[1][3]/root2;
      T(2,2,1,2) = T(2,2,2,1) = M[2][3]/root2;
      T(1,2,1,2) = T(2,1,1,2) = T(1,2,2,1) = T(2,1,2,1) = M[3][3]/2.0;
      T(2,0,1,2) = T(0,2,1,2) = T(2,0,2,1) = T(0,2,2,1) = M[4][3]/2.0;
      T(0,1,1,2) = T(1,0,1,2) = T(0,1,2,1) = T(1,0,2,1) = M[5][3]/2.0;
      
      T(0,0,2,0) = T(0,0,0,2) = M[0][4]/root2;
      T(1,1,2,0) = T(1,1,0,2) = M[1][4]/root2;
      T(2,2,2,0) = T(2,2,0,2) = M[2][4]/root2;
      T(1,2,2,0) = T(2,1,2,0) = T(1,2,0,2) = T(2,1,0,2) = M[3][4]/2.0;
      T(2,0,2,0) = T(0,2,2,0) = T(2,0,0,2) = T(0,2,0,2) = M[4][4]/2.0;
      T(0,1,2,0) = T(1,0,2,0) = T(0,1,0,2) = T(1,0,0,2) = M[5][4]/2.0;
      
      T(0,0,0,1) = T(0,0,1,0) = M[0][5]/root2;
      T(1,1,0,1) = T(1,1,1,0) = M[1][5]/root2;
      T(2,2,0,1) = T(2,2,1,0) = M[2][5]/root2;
      T(1,2,0,1) = T(2,1,0,1) = T(1,2,1,0) = T(2,1,1,0) = M[3][5]/2.0;
      T(2,0,0,1) = T(0,2,0,1) = T(2,0,1,0) = T(0,2,1,0) = M[4][5]/2.0;
      T(0,1,0,1) = T(1,0,0,1) = T(0,1,1,0) = T(1,0,1,0) = M[5][5]/2.0;
      
      return T;
   }
   cerr << "Function Type3333sym error!\n";
   exit(1);
}

//99->3333ƥ󥽥
Tensor3333
Type3333(const Mat& M)
{
   Tensor3333 T;
   int kap, lam;
   
   for (int i = 0; i < 3; i++)
      for (int j = 0; j < 3; j++)
	 for (int k = 0; k < 3; k++)
	    for (int l = 0; l < 3; l++)
	    {
	       kap = 3 * i + j;
	       lam = 3 * k + l;
	       T(i, j, k, l) = M[kap][lam];
	    }
   
   return T;
}
